Bug 180854 - Deadlock installing new version of Composer
Deadlock installing new version of Composer
Status: RESOLVED FIXED
Product: java
Classification: Unclassified
Component: Source
6.x
Macintosh (x86) Mac OS X
: P2 (vote)
: 6.x
Assigned To: Jan Lahoda
issues@java
: THREAD
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2010-02-17 10:12 UTC by emcmanus
Modified: 2010-03-24 05:21 UTC (History)
0 users

See Also:
Issue Type: DEFECT
:


Attachments
Full output of jstack on deadlocked process (18.88 KB, text/plain)
2010-02-17 10:12 UTC, emcmanus
Details

Note You need to log in before you can comment on or make changes to this bug.
Description emcmanus 2010-02-17 10:12:21 UTC
Created attachment 94243 [details]
Full output of jstack on deadlocked process

I'm running a prerelease of 6.8 Patch 1.  Today it proposed to install an update to the JavaFX Composer.  On restarting it hit this deadlock as reported by jstack:

Found one Java-level deadlock:
=============================
"JavaFX Node Badge Processor":
  waiting to lock monitor 0x0000000101870da0 (object 0x000000010acf88c0, a org.netbeans.modules.javafx.source.usages.BuildArtifactMapperImpl$FileBuildQueryImpl),
  which is held by "Java Node Badge Processor"
"Java Node Badge Processor":
  waiting to lock monitor 0x0000000101870ef0 (object 0x000000010acf88a0, a org.netbeans.modules.java.source.usages.BuildArtifactMapperImpl$FileBuildQueryImpl),
  which is held by "JavaFX Node Badge Processor"

Java stack information for the threads listed above:
===================================================
"JavaFX Node Badge Processor":
	at org.netbeans.modules.javafx.source.usages.BuildArtifactMapperImpl$FileBuildQueryImpl.getStatus(BuildArtifactMapperImpl.java:477)
	- waiting to lock <0x000000010acf88c0> (a org.netbeans.modules.javafx.source.usages.BuildArtifactMapperImpl$FileBuildQueryImpl)
	at org.netbeans.api.queries.FileBuiltQuery.getStatus(FileBuiltQuery.java:99)
	at org.netbeans.modules.java.source.usages.BuildArtifactMapperImpl$FileBuildQueryImpl.getStatus(BuildArtifactMapperImpl.java:657)
	- locked <0x000000010acf88a0> (a org.netbeans.modules.java.source.usages.BuildArtifactMapperImpl$FileBuildQueryImpl)
	at org.netbeans.api.queries.FileBuiltQuery.getStatus(FileBuiltQuery.java:99)
	at org.netbeans.modules.javafx.dataloader.JavaFXDataNode$BuildStatusTask.run(JavaFXDataNode.java:319)
	at org.openide.util.RequestProcessor$Task.run(RequestProcessor.java:602)
	at org.openide.util.RequestProcessor$Processor.run(RequestProcessor.java:1084)
"Java Node Badge Processor":
	at org.netbeans.modules.java.source.usages.BuildArtifactMapperImpl$FileBuildQueryImpl.getStatus(BuildArtifactMapperImpl.java:643)
	- waiting to lock <0x000000010acf88a0> (a org.netbeans.modules.java.source.usages.BuildArtifactMapperImpl$FileBuildQueryImpl)
	at org.netbeans.api.queries.FileBuiltQuery.getStatus(FileBuiltQuery.java:99)
	at org.netbeans.modules.javafx.source.usages.BuildArtifactMapperImpl$FileBuildQueryImpl.getStatus(BuildArtifactMapperImpl.java:491)
	- locked <0x000000010acf88c0> (a org.netbeans.modules.javafx.source.usages.BuildArtifactMapperImpl$FileBuildQueryImpl)
	at org.netbeans.api.queries.FileBuiltQuery.getStatus(FileBuiltQuery.java:99)
	at org.netbeans.modules.java.JavaNode$BuildStatusTask.run(JavaNode.java:326)
	at org.openide.util.RequestProcessor$Task.run(RequestProcessor.java:602)
	at org.openide.util.RequestProcessor$Processor.run(RequestProcessor.java:1084)
Comment 1 David Kaspar 2010-03-03 09:15:59 UTC
Reassigning to Adam since it is a deadlock in the JavaFX badge resolving/setting.
Comment 2 Adam Sotona 2010-03-22 14:37:21 UTC
fixed in http://hg.netbeans.org/javafx/rev/cf37ec81e196
Comment 3 Adam Sotona 2010-03-22 14:44:21 UTC
I am forwarding this issue also to Java module. BuildArtifactMapperImpl.FileBuildQueryImpl from Java module is identical and the deadlock is symmetrical so the same fix should work.
Comment 4 Jan Lahoda 2010-03-23 15:23:13 UTC
http://hg.netbeans.org/jet-main/rev/5f6fc17af727
Comment 5 Quality Engineering 2010-03-24 05:21:48 UTC
Integrated into 'main-golden', will be available in build *201003240200* on http://bits.netbeans.org/dev/nightly/ (upload may still be in progress)
Changeset: http://hg.netbeans.org/main/rev/5f6fc17af727
User: Jan Lahoda <jlahoda@netbeans.org>
Log: #180854: fixing deadlock.


By use of this website, you agree to the NetBeans Policies and Terms of Use. © 2012, Oracle Corporation and/or its affiliates. Sponsored by Oracle logo